package com.engine.seclinktel.web;


import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.engine.common.util.ServiceUtil;
import com.engine.seclinktel.entity.QuantitativeData;
import com.engine.seclinktel.service.PerformanceWorkflowService;
import com.engine.seclinktel.service.impl.PerformanceWorkflowServiceImpl;
import io.swagger.v3.oas.annotations.parameters.RequestBody;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2025/6/19 11:04
 * @Description: TODO
 * @Version 1.0
 */
public class PerformanceWorkflowAction {

    private PerformanceWorkflowService getService(User user) {
        return  ServiceUtil.getService(PerformanceWorkflowServiceImpl.class, user);
    }



    @POST
    @Path("/buildDetailData")
    @Produces(MediaType.TEXT_PLAIN)
    public String recordSignData(@Context HttpServletRequest request, @Context HttpServletResponse response, @RequestBody QuantitativeData quantitativeData){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("result",getService(user).buildDetailData(quantitativeData));
            data.put("api_status", true);
        } catch (Exception e) {
            data.put("api_status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }
}
